unit consts;

interface

{$R consts.RES}

const
  SAssignError = 61440;
  SFCreateError = 61441;
  SFOpenError = 61442;
  SReadError = 61443;
  SWriteError = 61444;
  SMemoryStreamError = 61445;
  SCantWriteResourceStreamError = 61446;
  SDuplicateReference = 61447;
  SClassNotFound = 61448;
  SInvalidImage = 61449;
  SResNotFound = 61450;
  SClassMismatch = 61451;
  SListIndexError = 61452;
  SSortedListError = 61453;
  SDuplicateString = 61454;
  SInvalidTabIndex = 61455;
  SDuplicateName = 61456;
  SInvalidName = 61457;
  SDuplicateClass = 61458;
  SInvalidInteger = 61459;
  SLineTooLong = 61460;
  SInvalidPropertyValue = 61461;
  SInvalidPropertyPath = 61462;
  SUnknownProperty = 61463;
  SReadOnlyProperty = 61464;
  SPropertyException = 61465;
  SAncestorNotFound = 61466;
  SInvalidBitmap = 61467;
  SInvalidIcon = 61468;
  SInvalidMetafile = 61469;
  SBitmapEmpty = 61470;
  SChangeIconSize = 61471;
  SUnknownExtension = 61472;
  SUnknownClipboardFormat = 61473;
  SOutOfResources = 61474;
  SNoCanvasHandle = 61475;
  SInvalidImageSize = 61476;
  STooManyImages = 61477;
  SDimsDoNotMatch = 61478;
  SInvalidImageList = 61479;
  SReplaceImage = 61480;
  SImageIndexError = 61481;
  SWindowDCError = 61482;
  SClientNotSet = 61483;
  SWindowClass = 61484;
  SWindowCreate = 61485;
  SCannotFocus = 61486;
  SParentRequired = 61487;
  SMDIChildNotVisible = 61488;
  SVisibleChanged = 61489;
  SCannotShowModal = 61490;
  SScrollBarRange = 61491;
  SPropertyOutOfRange = 61492;
  SMenuIndexError = 61493;
  SMenuReinserted = 61494;
  SMenuNotFound = 61495;
  SNoTimers = 61496;
  SNotPrinting = 61497;
  SPrinting = 61498;
  SPrinterIndexError = 61499;
  SInvalidPrinter = 61500;
  SDeviceOnPort = 61501;
  SGroupIndexTooLow = 61502;
  STwoMDIForms = 61503;
  SNoMDIForm = 61504;
  SRegisterError = 61505;
  SImageCanvasNeedsBitmap = 61506;
  SControlParentSetToSelf = 61507;
  SOKButton = 61508;
  SCancelButton = 61509;
  SYesButton = 61510;
  SNoButton = 61511;
  SHelpButton = 61512;
  SCloseButton = 61513;
  SIgnoreButton = 61514;
  SRetryButton = 61515;
  SAbortButton = 61516;
  SAllButton = 61517;
  SCannotDragForm = 61518;
  SPutObjectError = 61519;
  SCardDLLNotLoaded = 61520;
  SDuplicateCardId = 61521;
  SDdeErr = 61522;
  SDdeConvErr = 61523;
  SDdeMemErr = 61524;
  SDdeNoConnect = 61525;
  SFB = 61526;
  SFG = 61527;
  SBG = 61528;
  SOldTShape = 61529;
  SVMetafiles = 61530;
  SVEnhMetafiles = 61531;
  SVIcons = 61532;
  SVBitmaps = 61533;
  SGridTooLarge = 61534;
  STooManyDeleted = 61535;
  SIndexOutOfRange = 61536;
  SFixedColTooBig = 61537;
  SFixedRowTooBig = 61538;
  SParseError = 61539;
  SIdentifierExpected = 61540;
  SStringExpected = 61541;
  SNumberExpected = 61542;
  SCharExpected = 61543;
  SSymbolExpected = 61544;
  SInvalidNumber = 61545;
  SInvalidString = 61546;
  SInvalidProperty = 61547;
  SInvalidBinary = 61548;
  SOutlineIndexError = 61549;
  SOutlineExpandError = 61550;
  SInvalidCurrentItem = 61551;
  SMaskErr = 61552;
  SMaskEditErr = 61553;
  SOutlineError = 61554;
  SOutlineBadLevel = 61555;
  SOutlineSelection = 61556;
  SOutlineFileLoad = 61557;
  SOutlineLongLine = 61558;
  SOutlineMaxLevels = 61559;
  SMsgDlgWarning = 61560;
  SMsgDlgError = 61561;
  SMsgDlgInformation = 61562;
  SMsgDlgConfirm = 61563;
  SMsgDlgYes = 61564;
  SMsgDlgNo = 61565;
  SMsgDlgOK = 61566;
  SMsgDlgCancel = 61567;
  SMsgDlgHelp = 61568;
  SMsgDlgHelpNone = 61569;
  SMsgDlgHelpHelp = 61570;
  SMsgDlgAbort = 61571;
  SMsgDlgRetry = 61572;
  SMsgDlgIgnore = 61573;
  SMsgDlgAll = 61574;
  SmkcBkSp = 61575;
  SmkcTab = 61576;
  SmkcEsc = 61577;
  SmkcEnter = 61578;
  SmkcSpace = 61579;
  SmkcPgUp = 61580;
  SmkcPgDn = 61581;
  SmkcEnd = 61582;
  SmkcHome = 61583;
  SmkcLeft = 61584;
  SmkcUp = 61585;
  SmkcRight = 61586;
  SmkcDown = 61587;
  SmkcIns = 61588;
  SmkcDel = 61589;
  SmkcShift = 61590;
  SmkcCtrl = 61591;
  SmkcAlt = 61592;
  srUnknown = 61593;
  srNone = 61594;
  SOutOfRange = 61595;
  SCannotCreateName = 61596;
  SDateEncodeError = 61597;
  STimeEncodeError = 61598;
  SInvalidDate = 61599;
  SInvalidTime = 61600;
  SInvalidDateTime = 61601;
  SInvalidFileName = 61602;
  SDefaultFilter = 61603;
  sAllFilter = 61604;
  SNoVolumeLabel = 61605;
  SInsertLineError = 61606;
  SConfirmCreateDir = 61607;
  SSelectDirCap = 61608;
  SDirNameCap = 61609;
  SDrivesCap = 61610;
  SDirsCap = 61611;
  SFilesCap = 61612;
  SNetworkCap = 61613;
  SColorPrefix = 61614;
  SColorTags = 61615;
  SInvalidClipFmt = 61616;
  SIconToClipboard = 61617;
  SDefault = 61618;
  SInvalidMemoSize = 61619;
  SCustomColors = 61620;
  SInvalidPrinterOp = 61621;
  SNoDefaultPrinter = 61622;
  SIniFileWriteError = 61623;
  SBitsIndexError = 61624;
  SUntitled = 61625;
  SInvalidRegType = 61626;
  SRegCreateFailed = 61627;
  SRegSetDataFailed = 61628;
  SRegGetDataFailed = 61629;
  SMainThreadWaiting = 61630;
  SUnknownConversion = 61631;
  SDuplicateMenus = 61632;
  SNotOpenErr = 61648;
  SMPOpenFilter = 61649;
  SMCINil = 61650;
  SMCIAVIVideo = 61651;
  SMCICDAudio = 61652;
  SMCIDAT = 61653;
  SMCIDigitalVideo = 61654;
  SMCIMMMovie = 61655;
  SMCIOther = 61656;
  SMCIOverlay = 61657;
  SMCIScanner = 61658;
  SMCISequencer = 61659;
  SMCIVCR = 61660;
  SMCIVideodisc = 61661;
  SMCIWaveAudio = 61662;
  SMCIUnknownError = 61663;

implementation

end.