unit VCFImprs;

interface

uses Ole2, OleCtl, Classes, Graphics, OleCtrls;

const

{ FontStyleConstants }

  VtFontStyleBold = 1;
  VtFontStyleItalic = 2;
  VtFontStyleOutline = 4;

{ FontEffectsConstants }

  VtFontEffectStrikeThrough = 256;
  VtFontEffectUnderline = 512;

{ FrameStyleConstants }

  VtFrameStyleNull = 0;
  VtFrameStyleSingleLine = 1;
  VtFrameStyleDoubleLine = 2;
  VtFrameStyleThickInner = 3;
  VtFrameStyleThickOuter = 4;

{ BrushStyleConstants }

  VtBrushStyleNull = 0;
  VtBrushStyleSolid = 1;
  VtBrushStylePattern = 2;
  VtBrushStyleHatched = 3;

{ LabelComponentConstants }

  VtChLabelComponentValue = 1;
  VtChLabelComponentPercent = 2;
  VtChLabelComponentSeriesName = 4;
  VtChLabelComponentPointName = 8;

{ BrushPatternConstants }

  VtBrushPattern94Percent = 0;
  VtBrushPattern88Percent = 1;
  VtBrushPattern75Percent = 2;
  VtBrushPattern50Percent = 3;
  VtBrushPattern25Percent = 4;
  VtBrushPatternBoldHorizontal = 5;
  VtBrushPatternBoldVertical = 6;
  VtBrushPatternBoldDownDiagonal = 7;
  VtBrushPatternBoldUpDiagonal = 8;
  VtBrushPatternChecks = 9;
  VtBrushPatternWeave = 10;
  VtBrushPatternHorizontal = 11;
  VtBrushPatternVertical = 12;
  VtBrushPatternDownDiagonal = 13;
  VtBrushPatternUpDiagonal = 14;
  VtBrushPatternGrid = 15;
  VtBrushPatternTrellis = 16;
  VtBrushPatternInvertedTrellis = 17;

{ BrushHatchConstants }

  VtBrushHatchHorizontal = 0;
  VtBrushHatchVertical = 1;
  VtBrushHatchDownDiagonal = 2;
  VtBrushHatchUpDiagonal = 3;
  VtBrushHatchCross = 4;
  VtBrushHatchDiagonalCross = 5;

{ ShadowStyleConstants }

  VtShadowStyleNull = 0;
  VtShadowStyleDrop = 1;

{ MouseFlagConstants }

  VtChMouseFlagShiftKeyDown = 4;
  VtChMouseFlagControlKeyDown = 8;

{ PenStyleConstants }

  VtPenStyleNull = 0;
  VtPenStyleSolid = 1;
  VtPenStyleDashed = 2;
  VtPenStyleDotted = 3;
  VtPenStyleDashDot = 4;
  VtPenStyleDashDotDot = 5;
  VtPenStyleDitted = 6;
  VtPenStyleDashDit = 7;
  VtPenStyleDashDitDit = 8;

{ PenJoinConstants }

  VtPenJoinMiter = 0;
  VtPenJoinRound = 1;
  VtPenJoinBevel = 2;

{ PenCapConstants }

  VtPenCapButt = 0;
  VtPenCapRound = 1;
  VtPenCapSquare = 2;

{ GradientStyleConstants }

  VtGradientStyleHorizontal = 0;
  VtGradientStyleVertical = 1;
  VtGradientStyleRectangle = 2;
  VtGradientStyleOval = 3;

{ PictureTypeConstants }

  VtPictureTypeNull = 0;
  VtPictureTypeBMP = 1;
  VtPictureTypeWMF = 2;

{ PictureOptionConstants }

  VtPictureOptionNoSizeHeader = 0;
  VtPictureOptionTextAsCurves = 1;

{ PictureMapTypeConstants }

  VtPictureMapTypeActual = 0;
  VtPictureMapTypeFitted = 1;
  VtPictureMapTypeStretched = 2;
  VtPictureMapTypeTiled = 3;
  VtPictureMapTypeCropFitted = 4;

{ FillStyleConstants }

  VtFillStyleNull = 0;
  VtFillStyleBrush = 1;
  VtFillStyleGradient = 2;

{ LocationTypeConstants }

  VtChLocationTypeTopLeft = 0;
  VtChLocationTypeTop = 1;
  VtChLocationTypeTopRight = 2;
  VtChLocationTypeLeft = 3;
  VtChLocationTypeRight = 4;
  VtChLocationTypeBottomLeft = 5;
  VtChLocationTypeBottom = 6;
  VtChLocationTypeBottomRight = 7;
  VtChLocationTypeCustom = 8;

{ AxisIdConstants }

  VtChAxisIdX = 0;
  VtChAxisIdY = 1;
  VtChAxisIdY2 = 2;
  VtChAxisIdZ = 3;

{ AxisTickStyleConstants }

  VtChAxisTickStyleNone = 0;
  VtChAxisTickStyleCenter = 1;
  VtChAxisTickStyleInside = 2;
  VtChAxisTickStyleOutside = 3;

{ DateIntervalTypeConstants }

  VtChDateIntervalTypeNone = 0;
  VtChDateIntervalTypeDaily = 1;
  VtChDateIntervalTypeWeekly = 2;
  VtChDateIntervalTypeSemimonthly = 3;
  VtChDateIntervalTypeMonthly = 4;
  VtChDateIntervalTypeYearly = 5;

{ ScaleTypeConstants }

  VtChScaleTypeLinear = 0;
  VtChScaleTypeLogarithmic = 1;
  VtChScaleTypePercent = 2;

{ PercentAxisBasisConstants }

  VtChPercentAxisBasisMaxChart = 0;
  VtChPercentAxisBasisMaxRow = 1;
  VtChPercentAxisBasisMaxColumn = 2;
  VtChPercentAxisBasisSumChart = 3;
  VtChPercentAxisBasisSumRow = 4;
  VtChPercentAxisBasisSumColumn = 5;

{ PieWeightBasisConstants }

  VtChPieWeightBasisNone = 0;
  VtChPieWeightBasisTotal = 1;
  VtChPieWeightBasisSeries = 2;

{ PieWeightStyleConstants }

  VtChPieWeightStyleArea = 0;
  VtChPieWeightStyleDiameter = 1;

{ SortTypeConstants }

  VtSortTypeNone = 0;
  VtSortTypeAscending = 1;
  VtSortTypeDescending = 2;

{ AngleUnitsConstants }

  VtAngleUnitsDegrees = 0;
  VtAngleUnitsRadians = 1;
  VtAngleUnitsGrads = 2;

{ SubPlotLabelLocationTypeConstants }

  VtChSubPlotLabelLocationTypeNone = 0;
  VtChSubPlotLabelLocationTypeAbove = 1;
  VtChSubPlotLabelLocationTypeBelow = 2;
  VtChSubPlotLabelLocationTypeCenter = 3;

{ LabelLineStyleConstants }

  VtChLabelLineStyleNone = 0;
  VtChLabelLineStyleStraight = 1;
  VtChLabelLineStyleBent = 2;

{ LabelLocationTypeConstants }

  VtChLabelLocationTypeNone = 0;
  VtChLabelLocationTypeAbovePoint = 1;
  VtChLabelLocationTypeBelowPoint = 2;
  VtChLabelLocationTypeCenter = 3;
  VtChLabelLocationTypeBase = 4;
  VtChLabelLocationTypeInside = 5;
  VtChLabelLocationTypeOutside = 6;
  VtChLabelLocationTypeLeft = 7;
  VtChLabelLocationTypeRight = 8;

{ ContourColorTypeConstants }

  VtChContourColorTypeAutomatic = 0;
  VtChContourColorTypeGradient = 1;
  VtChContourColorTypeManual = 2;

{ ContourDisplayTypeConstants }

  VtChContourDisplayTypeCBands = 0;
  VtChContourDisplayTypeCLines = 1;

{ SurfaceBaseTypeConstants }

  VtChSurfaceBaseTypePedestal = 0;
  VtChSurfaceBaseTypeStandard = 1;
  VtChSurfaceBaseTypeStandardWithCBands = 2;
  VtChSurfaceBaseTypeStandardWithCLines = 3;

{ SurfaceDisplayTypeConstants }

  VtChSurfaceDisplayTypeNone = 0;
  VtChSurfaceDisplayTypeCBands = 1;
  VtChSurfaceDisplayTypeCLines = 2;
  VtChSurfaceDisplayTypeSolid = 3;
  VtChSurfaceDisplayTypeSolidWithCLines = 4;

{ SurfaceProjectionTypeConstants }

  VtChSurfaceProjectionTypeNone = 0;
  VtChSurfaceProjectionTypeCBands = 1;
  VtChSurfaceProjectionTypeCLines = 2;

{ SurfaceWireframeTypeConstants }

  VtChSurfaceWireframeTypeNone = 0;
  VtChSurfaceWireframeTypeMajor = 1;
  VtChSurfaceWireframeTypeMajorAndMinor = 2;

{ MarkerStyleConstants }

  VtMarkerStyleDash = 0;
  VtMarkerStylePlus = 1;
  VtMarkerStyleX = 2;
  VtMarkerStyleStar = 3;
  VtMarkerStyleCircle = 4;
  VtMarkerStyleSquare = 5;
  VtMarkerStyleDiamond = 6;
  VtMarkerStyleUpTriangle = 7;
  VtMarkerStyleDownTriangle = 8;
  VtMarkerStyleFilledCircle = 9;
  VtMarkerStyleFilledSquare = 10;
  VtMarkerStyleFilledDiamond = 11;
  VtMarkerStyleFilledUpTriangle = 12;
  VtMarkerStyleFilledDownTriangle = 13;
  VtMarkerStyle3dBall = 14;

{ ProjectionTypeConstants }

  VtProjectionTypePerspective = 0;
  VtProjectionTypeOblique = 1;
  VtProjectionTypeOrthogonal = 2;

{ SmoothingTypeConstants }

  VtSmoothingTypeNone = 0;
  VtSmoothingTypeQuadraticBSpline = 1;
  VtSmoothingTypeCubicBSpline = 2;

{ HorizontalAlignmentConstants }

  VtHorizontalAlignmentLeft = 0;
  VtHorizontalAlignmentRight = 1;
  VtHorizontalAlignmentCenter = 2;

{ VerticalAlignmentConstants }

  VtVerticalAlignmentTop = 0;
  VtVerticalAlignmentBottom = 1;
  VtVerticalAlignmentCenter = 2;

{ OrientationConstants }

  VtOrientationHorizontal = 0;
  VtOrientationVertical = 1;
  VtOrientationUp = 2;
  VtOrientationDown = 3;

{ DcTypeConstants }

  VtDcTypeNull = 0;
  VtDcTypeDisplay = 1;
  VtDcTypePrinter = 2;
  VtDcTypeMetafile = 3;

{ PrintScaleTypeConstants }

  VtPrintScaleTypeActual = 0;
  VtPrintScaleTypeFitted = 1;
  VtPrintScaleTypeStretched = 2;

{ StatTypeConstants }

  VtChStatsMinimum = 1;
  VtChStatsMaximum = 2;
  VtChStatsMean = 4;
  VtChStatsStddev = 8;
  VtChStatsRegression = 16;

{ PrintOrientationTypeConstants }

  VtPrintOrientationPortrait = 0;
  VtPrintOrientationLandscape = 1;

{ TextOutputTypeConstants }

  VtTextOutputTypeHardware = 0;
  VtTextOutputTypePolygon = 1;

{ TextLengthTypeConstants }

  VtTextLengthTypeVirtual = 0;
  VtTextLengthTypeDevice = 1;

{ PartTypeConstants }

  VtChPartTypeChart = 0;
  VtChPartTypeTitle = 1;
  VtChPartTypeFootnote = 2;
  VtChPartTypeLegend = 3;
  VtChPartTypePlot = 4;
  VtChPartTypeSeries = 5;
  VtChPartTypeSeriesLabel = 6;
  VtChPartTypePoint = 7;
  VtChPartTypePointLabel = 8;
  VtChPartTypeAxis = 9;
  VtChPartTypeAxisLabel = 10;
  VtChPartTypeAxisTitle = 11;

{ DrawModeConstants }

  VtChDrawModeDraw = 0;
  VtChDrawModeBlit = 1;

{ SsLinkModeConstants }

  VtChSsLinkModeOff = 0;
  VtChSsLinkModeOn = 1;
  VtChSsLinkModeAutoParse = 2;

{ SeriesTypeConstants }

  VtChSeriesTypeDefault = -1;
  VtChSeriesType3dBar = 0;
  VtChSeriesType2dBar = 1;
  VtChSeriesType3dHorizontalBar = 2;
  VtChSeriesType2dHorizontalBar = 3;
  VtChSeriesType3dClusteredBar = 4;
  VtChSeriesType3dLine = 5;
  VtChSeriesType2dLine = 6;
  VtChSeriesType3dArea = 7;
  VtChSeriesType2dArea = 8;
  VtChSeriesType3dStep = 9;
  VtChSeriesType2dStep = 10;
  VtChSeriesType2dXY = 11;
  VtChSeriesType2dPolar = 12;
  VtChSeriesType2dRadarLine = 13;
  VtChSeriesType2dRadarArea = 14;
  VtChSeriesType2dBubble = 15;
  VtChSeriesType2dHiLo = 16;
  VtChSeriesType2dHLC = 17;
  VtChSeriesType2dHLCRight = 18;
  VtChSeriesType2dOHLC = 19;
  VtChSeriesType2dOHLCBar = 20;
  VtChSeriesType2dGantt = 21;
  VtChSeriesType3dGantt = 22;
  VtChSeriesType3dPie = 23;
  VtChSeriesType2dPie = 24;
  VtChSeriesType3dDoughnut = 25;
  VtChSeriesType2dDates = 26;
  VtChSeriesType3dBarHiLo = 27;
  VtChSeriesType2dBarHiLo = 28;
  VtChSeriesType3dHorizontalBarHiLo = 29;
  VtChSeriesType2dHorizontalBarHiLo = 30;
  VtChSeriesType3dClusteredBarHiLo = 31;
  VtChSeriesType3dSurface = 32;
  VtChSeriesType2dContour = 33;
  VtChSeriesType3dXYZ = 34;

{ ChartTypeConstants }

  VtChChartType3dBar = 0;
  VtChChartType2dBar = 1;
  VtChChartType3dLine = 2;
  VtChChartType2dLine = 3;
  VtChChartType3dArea = 4;
  VtChChartType2dArea = 5;
  VtChChartType3dStep = 6;
  VtChChartType2dStep = 7;
  VtChChartType3dCombination = 8;
  VtChChartType2dCombination = 9;
  VtChChartType3dHorizontalBar = 10;
  VtChChartType2dHorizontalBar = 11;
  VtChChartType3dClusteredBar = 12;
  VtChChartType3dPie = 13;
  VtChChartType2dPie = 14;
  VtChChartType3dDoughnut = 15;
  VtChChartType2dXY = 16;
  VtChChartType2dPolar = 17;
  VtChChartType2dRadar = 18;
  VtChChartType2dBubble = 19;
  VtChChartType2dHiLo = 20;
  VtChChartType2dGantt = 21;
  VtChChartType3dGantt = 22;
  VtChChartType3dSurface = 23;
  VtChChartType2dContour = 24;
  VtChChartType3dScatter = 25;
  VtChChartType3dXYZ = 26;

type

  TVCFirstImpressionChartSelected = procedure(Sender: TObject; var MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionTitleSelected = procedure(Sender: TObject; var MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionFootnoteSelected = procedure(Sender: TObject; var MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionLegendSelected = procedure(Sender: TObject; var MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionPlotSelected = procedure(Sender: TObject; var MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionAxisSelected = procedure(Sender: TObject; var AxisId, AxisIndex, MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionAxisLabelSelected = procedure(Sender: TObject; var AxisId, AxisIndex, labelSetIndex, LabelIndex, MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionAxisTitleSelected = procedure(Sender: TObject; var AxisId, AxisIndex, MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionPointSelected = procedure(Sender: TObject; var Series, DataPoint, MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionPointLabelSelected = procedure(Sender: TObject; var Series, DataPoint, MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionSeriesSelected = procedure(Sender: TObject; var Series, MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionSeriesLabelSelected = procedure(Sender: TObject; var Series, MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionChartActivated = procedure(Sender: TObject; var MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionTitleActivated = procedure(Sender: TObject; var MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionFootnoteActivated = procedure(Sender: TObject; var MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionLegendActivated = procedure(Sender: TObject; var MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionPlotActivated = procedure(Sender: TObject; var MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionAxisActivated = procedure(Sender: TObject; var AxisId, AxisIndex, MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionAxisLabelActivated = procedure(Sender: TObject; var AxisId, AxisIndex, labelSetIndex, LabelIndex, MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionAxisTitleActivated = procedure(Sender: TObject; var AxisId, AxisIndex, MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionPointActivated = procedure(Sender: TObject; var Series, DataPoint, MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionPointLabelActivated = procedure(Sender: TObject; var Series, DataPoint, MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionSeriesActivated = procedure(Sender: TObject; var Series, MouseFlags, Cancel: Smallint) of object;
  TVCFirstImpressionSeriesLabelActivated = procedure(Sender: TObject; var Series, MouseFlags, Cancel: Smallint) of object;

  TVCFirstImpression = class(TOleControl)
  private
    FOnChartSelected: TVCFirstImpressionChartSelected;
    FOnTitleSelected: TVCFirstImpressionTitleSelected;
    FOnFootnoteSelected: TVCFirstImpressionFootnoteSelected;
    FOnLegendSelected: TVCFirstImpressionLegendSelected;
    FOnPlotSelected: TVCFirstImpressionPlotSelected;
    FOnAxisSelected: TVCFirstImpressionAxisSelected;
    FOnAxisLabelSelected: TVCFirstImpressionAxisLabelSelected;
    FOnAxisTitleSelected: TVCFirstImpressionAxisTitleSelected;
    FOnPointSelected: TVCFirstImpressionPointSelected;
    FOnPointLabelSelected: TVCFirstImpressionPointLabelSelected;
    FOnSeriesSelected: TVCFirstImpressionSeriesSelected;
    FOnSeriesLabelSelected: TVCFirstImpressionSeriesLabelSelected;
    FOnChartActivated: TVCFirstImpressionChartActivated;
    FOnTitleActivated: TVCFirstImpressionTitleActivated;
    FOnFootnoteActivated: TVCFirstImpressionFootnoteActivated;
    FOnLegendActivated: TVCFirstImpressionLegendActivated;
    FOnPlotActivated: TVCFirstImpressionPlotActivated;
    FOnAxisActivated: TVCFirstImpressionAxisActivated;
    FOnAxisLabelActivated: TVCFirstImpressionAxisLabelActivated;
    FOnAxisTitleActivated: TVCFirstImpressionAxisTitleActivated;
    FOnPointActivated: TVCFirstImpressionPointActivated;
    FOnPointLabelActivated: TVCFirstImpressionPointLabelActivated;
    FOnSeriesActivated: TVCFirstImpressionSeriesActivated;
    FOnSeriesLabelActivated: TVCFirstImpressionSeriesLabelActivated;
    FOnApplyChanges: TNotifyEvent;
    function Get_GetBitmap(const options: Variant): Integer; stdcall;
  protected
    procedure InitControlData; override;
  public
    procedure EditPaste; stdcall;
    procedure EditCopy; stdcall;
    procedure ActivateSelectionDialog; stdcall;
    procedure Layout; stdcall;
    procedure ToDefaults; stdcall;
    procedure PrintSetupDialog; stdcall;
    procedure PrintChart; stdcall;
    procedure SelectPart(part, index1, index2, index3, index4: Smallint); stdcall;
    procedure GetSelectedPart(var part, index1, index2, index3, index4: Smallint); stdcall;
    procedure GetDLLVersion(var major, minor: Smallint); stdcall;
    procedure TwipsToChartPart(xVal, yVal: Integer; var part, index1, index2, index3, index4: Smallint); stdcall;
    procedure ReadFromFile(const FileName: string); stdcall;
    procedure WritePictureToFile(const FileName: string; pictureType, options: Smallint); stdcall;
    procedure WriteToFile(const FileName: string); stdcall;
    procedure ActivateFormatMenu(X, Y: Integer); stdcall;
    procedure GetMetafile(options: Smallint; var Handle, Width, Height: Integer); stdcall;
    procedure CopyDataFromArray(Top, Left, Bottom, Right: Smallint; const Array_: Variant); stdcall;
    procedure CopyDataToArray(Top, Left, Bottom, Right: Smallint; const Array_: Variant); stdcall;
    procedure Draw(hDC: Integer; hDCType: Smallint; Top, Left, Bottom, Right: Integer; Layout, Stretch: TOleBool); stdcall;
    procedure UseWizard; stdcall;
    procedure EditChartData; stdcall;
    procedure Refresh; stdcall;
    procedure AboutBox; stdcall;
    property SsLinkSheet: string index 22 read GetStringProp write SetStringProp;
    property Handle: Integer index 24 read GetIntegerProp;
    property Picture: Variant index 25 read GetVariantProp;
    property GetBitmap[const options: Variant]: Integer read Get_GetBitmap;
  published
    property TabStop;
    property DragCursor;
    property DragMode;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property Visible;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnStartDrag;
    property OnClick;
    property OnDblClick;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property AutoIncrement: TOleBool index 1 read GetOleBoolProp write SetOleBoolProp stored False;
    property RandomFill: TOleBool index 2 read GetOleBoolProp write SetOleBoolProp stored False;
    property ChartType: Smallint index 3 read GetSmallintProp write SetSmallintProp stored False;
    property Column: Smallint index 4 read GetSmallintProp write SetSmallintProp stored False;
    property ColumnCount: Smallint index 5 read GetSmallintProp write SetSmallintProp stored False;
    property ColumnLabel: string index 6 read GetStringProp write SetStringProp stored False;
    property ColumnLabelCount: Smallint index 7 read GetSmallintProp write SetSmallintProp stored False;
    property ColumnLabelIndex: Smallint index 8 read GetSmallintProp write SetSmallintProp stored False;
    property Data: string index 9 read GetStringProp write SetStringProp stored False;
    property FootnoteText: string index 10 read GetStringProp write SetStringProp stored False;
    property Repaint: TOleBool index 11 read GetOleBoolProp write SetOleBoolProp stored False;
    property Row: Smallint index 12 read GetSmallintProp write SetSmallintProp stored False;
    property RowCount: Smallint index 13 read GetSmallintProp write SetSmallintProp stored False;
    property RowLabel: string index 14 read GetStringProp write SetStringProp stored False;
    property RowLabelCount: Smallint index 15 read GetSmallintProp write SetSmallintProp stored False;
    property RowLabelIndex: Smallint index 16 read GetSmallintProp write SetSmallintProp stored False;
    property SeriesColumn: Smallint index 17 read GetSmallintProp write SetSmallintProp stored False;
    property SeriesType: Smallint index 18 read GetSmallintProp write SetSmallintProp stored False;
    property ShowLegend: TOleBool index 19 read GetOleBoolProp write SetOleBoolProp stored False;
    property SsLinkMode: Smallint index 20 read GetSmallintProp write SetSmallintProp stored False;
    property SsLinkRange: string index 21 read GetStringProp write SetStringProp stored False;
    property DrawMode: Smallint index 23 read GetSmallintProp write SetSmallintProp stored False;
    property BorderStyle: Smallint index -504 read GetSmallintProp write SetSmallintProp stored False;
    property Enabled: TOleBool index -514 read GetOleBoolProp write SetOleBoolProp stored False;
    property hWnd: Smallint index -515 read GetSmallintProp write SetSmallintProp stored False;
    property Title: Variant index 26 read GetVariantProp write SetVariantProp stored False;
    property Footnote: Variant index 27 read GetVariantProp write SetVariantProp stored False;
    property TitleText: string index 28 read GetStringProp write SetStringProp stored False;
    property Stacking: TOleBool index 29 read GetOleBoolProp write SetOleBoolProp stored False;
    property TextLengthType: Smallint index 30 read GetSmallintProp write SetSmallintProp stored False;
    property AllowUserChanges: TOleBool index 31 read GetOleBoolProp write SetOleBoolProp stored False;
    property AllowSelections: TOleBool index 32 read GetOleBoolProp write SetOleBoolProp stored False;
    property AllowSeriesSelection: TOleBool index 33 read GetOleBoolProp write SetOleBoolProp stored False;
    property AllowDynamicRotation: TOleBool index 34 read GetOleBoolProp write SetOleBoolProp stored False;
    property ActiveSeriesCount: Smallint index 35 read GetSmallintProp write SetSmallintProp stored False;
    property Backdrop: Variant index 36 read GetVariantProp write SetVariantProp stored False;
    property PrintInformation: Variant index 37 read GetVariantProp write SetVariantProp stored False;
    property Legend: Variant index 38 read GetVariantProp write SetVariantProp stored False;
    property DataGrid: Variant index 39 read GetVariantProp write SetVariantProp stored False;
    property Plot: Variant index 40 read GetVariantProp write SetVariantProp stored False;
    property TwipsWidth: Integer index 41 read GetIntegerProp write SetIntegerProp stored False;
    property TwipsHeight: Integer index 42 read GetIntegerProp write SetIntegerProp stored False;
    property AllowDithering: TOleBool index 43 read GetOleBoolProp write SetOleBoolProp stored False;
    property ErrorOffset: Smallint index 44 read GetSmallintProp write SetSmallintProp stored False;
    property DoSetCursor: TOleBool index 45 read GetOleBoolProp write SetOleBoolProp stored False;
    property FileName: string index 46 read GetStringProp write SetStringProp stored False;
    property Chart3d: TOleBool index 47 read GetOleBoolProp write SetOleBoolProp stored False;
    property SsLinkBook: string index 48 read GetStringProp write SetStringProp stored False;
    property OnChartSelected: TVCFirstImpressionChartSelected read FOnChartSelected write FOnChartSelected;
    property OnTitleSelected: TVCFirstImpressionTitleSelected read FOnTitleSelected write FOnTitleSelected;
    property OnFootnoteSelected: TVCFirstImpressionFootnoteSelected read FOnFootnoteSelected write FOnFootnoteSelected;
    property OnLegendSelected: TVCFirstImpressionLegendSelected read FOnLegendSelected write FOnLegendSelected;
    property OnPlotSelected: TVCFirstImpressionPlotSelected read FOnPlotSelected write FOnPlotSelected;
    property OnAxisSelected: TVCFirstImpressionAxisSelected read FOnAxisSelected write FOnAxisSelected;
    property OnAxisLabelSelected: TVCFirstImpressionAxisLabelSelected read FOnAxisLabelSelected write FOnAxisLabelSelected;
    property OnAxisTitleSelected: TVCFirstImpressionAxisTitleSelected read FOnAxisTitleSelected write FOnAxisTitleSelected;
    property OnPointSelected: TVCFirstImpressionPointSelected read FOnPointSelected write FOnPointSelected;
    property OnPointLabelSelected: TVCFirstImpressionPointLabelSelected read FOnPointLabelSelected write FOnPointLabelSelected;
    property OnSeriesSelected: TVCFirstImpressionSeriesSelected read FOnSeriesSelected write FOnSeriesSelected;
    property OnSeriesLabelSelected: TVCFirstImpressionSeriesLabelSelected read FOnSeriesLabelSelected write FOnSeriesLabelSelected;
    property OnChartActivated: TVCFirstImpressionChartActivated read FOnChartActivated write FOnChartActivated;
    property OnTitleActivated: TVCFirstImpressionTitleActivated read FOnTitleActivated write FOnTitleActivated;
    property OnFootnoteActivated: TVCFirstImpressionFootnoteActivated read FOnFootnoteActivated write FOnFootnoteActivated;
    property OnLegendActivated: TVCFirstImpressionLegendActivated read FOnLegendActivated write FOnLegendActivated;
    property OnPlotActivated: TVCFirstImpressionPlotActivated read FOnPlotActivated write FOnPlotActivated;
    property OnAxisActivated: TVCFirstImpressionAxisActivated read FOnAxisActivated write FOnAxisActivated;
    property OnAxisLabelActivated: TVCFirstImpressionAxisLabelActivated read FOnAxisLabelActivated write FOnAxisLabelActivated;
    property OnAxisTitleActivated: TVCFirstImpressionAxisTitleActivated read FOnAxisTitleActivated write FOnAxisTitleActivated;
    property OnPointActivated: TVCFirstImpressionPointActivated read FOnPointActivated write FOnPointActivated;
    property OnPointLabelActivated: TVCFirstImpressionPointLabelActivated read FOnPointLabelActivated write FOnPointLabelActivated;
    property OnSeriesActivated: TVCFirstImpressionSeriesActivated read FOnSeriesActivated write FOnSeriesActivated;
    property OnSeriesLabelActivated: TVCFirstImpressionSeriesLabelActivated read FOnSeriesLabelActivated write FOnSeriesLabelActivated;
    property OnApplyChanges: TNotifyEvent read FOnApplyChanges write FOnApplyChanges;
  end;

procedure Register;

implementation

{$J+}

procedure TVCFirstImpression.InitControlData;
const
  CEventDispIDs: array[0..24] of Integer = (
    $00000001, $00000002, $00000003, $00000004, $00000005, $00000006,
    $00000007, $00000008, $00000009, $0000000A, $0000000B, $0000000C,
    $0000000D, $0000000E, $0000000F, $00000010, $00000011, $00000012,
    $00000013, $00000014, $00000015, $00000016, $00000017, $00000018,
    $00000019);
  CLicenseKey: array[0..42] of Word = (
    $0043, $006F, $0070, $0079, $0072, $0069, $0067, $0068, $0074, $0020,
    $0028, $0063, $0029, $0020, $0031, $0039, $0039, $0035, $0020, $0056,
    $0069, $0073, $0075, $0061, $006C, $0020, $0043, $006F, $006D, $0070,
    $006F, $006E, $0065, $006E, $0074, $0073, $002C, $0020, $0049, $006E,
    $0063, $002E, $0000);
  CControlData: TControlData = (
    ClassID: (
      D1:$5A721580;D2:$5AF0;D3:$11CE;D4:($83,$84,$00,$20,$AF,$23,$37,$F2));
    EventIID: (
      D1:$5A721582;D2:$5AF0;D3:$11CE;D4:($83,$84,$00,$20,$AF,$23,$37,$F2));
    EventCount: 25;
    EventDispIDs: @CEventDispIDs;
    LicenseKey: @CLicenseKey;
    Flags: $00000008);
begin
  ControlData := @CControlData;
end;

procedure TVCFirstImpression.EditPaste;
const
  DispInfo: array[0..7] of Byte = ($31,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.EditCopy;
const
  DispInfo: array[0..7] of Byte = ($32,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.ActivateSelectionDialog;
const
  DispInfo: array[0..7] of Byte = ($33,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.Layout;
const
  DispInfo: array[0..7] of Byte = ($34,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.ToDefaults;
const
  DispInfo: array[0..7] of Byte = ($35,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.PrintSetupDialog;
const
  DispInfo: array[0..7] of Byte = ($36,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.PrintChart;
const
  DispInfo: array[0..7] of Byte = ($37,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.SelectPart;
const
  DispInfo: array[0..12] of Byte = ($38,$00,$00,$00,$00,$01,$05,$00,$02,$02,$02,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.GetSelectedPart;
const
  DispInfo: array[0..12] of Byte = ($39,$00,$00,$00,$00,$01,$05,$00,$82,$82,$82,$82,$82);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.GetDLLVersion;
const
  DispInfo: array[0..9] of Byte = ($3A,$00,$00,$00,$00,$01,$02,$00,$82,$82);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.TwipsToChartPart;
const
  DispInfo: array[0..14] of Byte = ($3B,$00,$00,$00,$00,$01,$07,$00,$03,$03,$82,$82,$82,$82,$82);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.ReadFromFile;
const
  DispInfo: array[0..8] of Byte = ($3C,$00,$00,$00,$00,$01,$01,$00,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.WritePictureToFile;
const
  DispInfo: array[0..10] of Byte = ($3D,$00,$00,$00,$00,$01,$03,$00,$08,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.WriteToFile;
const
  DispInfo: array[0..8] of Byte = ($3E,$00,$00,$00,$00,$01,$01,$00,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.ActivateFormatMenu;
const
  DispInfo: array[0..9] of Byte = ($3F,$00,$00,$00,$00,$01,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.GetMetafile;
const
  DispInfo: array[0..11] of Byte = ($40,$00,$00,$00,$00,$01,$04,$00,$02,$83,$83,$83);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.CopyDataFromArray;
const
  DispInfo: array[0..12] of Byte = ($41,$00,$00,$00,$00,$01,$05,$00,$02,$02,$02,$02,$0C);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.CopyDataToArray;
const
  DispInfo: array[0..12] of Byte = ($42,$00,$00,$00,$00,$01,$05,$00,$02,$02,$02,$02,$0C);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.Draw;
const
  DispInfo: array[0..15] of Byte = ($43,$00,$00,$00,$00,$01,$08,$00,$03,$02,$03,$03,$03,$03,$0B,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.UseWizard;
const
  DispInfo: array[0..7] of Byte = ($44,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.EditChartData;
const
  DispInfo: array[0..7] of Byte = ($45,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.Refresh;
const
  DispInfo: array[0..7] of Byte = ($DA,$FD,$FF,$FF,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TVCFirstImpression.AboutBox;
const
  DispInfo: array[0..7] of Byte = ($D8,$FD,$FF,$FF,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

function TVCFirstImpression.Get_GetBitmap;
const
  DispInfo: array[0..8] of Byte = ($46,$00,$00,$00,$03,$02,$01,$00,$0C);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure Register;
begin
  RegisterComponents('OCX', [TVCFirstImpression]);
end;

end.
